<?PHP
    // First the version details
		include("version.php") ;		
		$this->values["version"]=$version ;
		$this->values["last_updated"]=$last_updated ;

		// TEDS or PBK in use?
		$this->values["use_teds"]=true ;
		$this->values["use_pbk"]=true ;
		$this->allowed_values["use_teds"]="boolean" ;
		$this->allowed_values["use_pbk"]="boolean" ;
 
    // Operating system where Toppy-Web is running
		$this->values["platform"]="windows" ;
		$this->allowed_values["platform"]=array("windows","slug","asus","linux","icebox2","macosx") ;
		
		 // FTP server details (these are the details of the FTP server that connects to the Toppy)
		$this->values["server_type"]="ftp4t" ;
		$this->allowed_values["server_type"]=array("ftpft","ftpd-topfield") ;
		
		$this->values["ftp_server"]="localhost" ;
		$this->values["ftp_port"]=21 ;
		$this->values["ftp_user"]="toppy-web" ;
		$this->values["ftp_pw"]="password" ;
		 
		 // Standard locations (there should be no need to change these values
		$this->values["epg_data"]="/EPGdata" ;
		$this->values["data_files"]="/DataFiles" ;
		$this->values["program_files"]="/ProgramFiles" ;
		$this->values["teds_location"]="C:\\Program Files\\teds" ;
		 
		 // this value is the character position of the filename in the list retrieved via FTP
		 // it varies depending on the server/platform used.
		$this->values["filename_offset"]=54 ;
		$this->allowed_values["filename_offset"]=array("depends"=>"ftp_server","ftp4t"=>54, "ftpd-topfield"=>51, "other"=>51) ;
		 
		 // Local files is a working folder where Toppy-web can stored files FTP'd from the Toppy
		 // Toppy-web needs read-write access to this folder
		 // the below values are suggested locations for each platform
		$this->values["local_files"]="C:\\Toppy-Web" ;
		$this->allowed_values["filename_offset"]=array("depends"=>"platform","windows"=>"C:\\Toppy-Web", "macosx"=>"/var/toppy-web", "other"=>"/opt/var/toppy-web") ;
		 
		 // Current timer locations (may reference standard locations)
		$this->values["epg_timers"]="epg_timers.tsv" ;
		$this->values["epg_timers_rem"]=$this->values["epg_data"] ;
		$this->values["epg_timers_loc"]=$this->values["local_files"] ;
		 
		 // Pending timer locations (may reference standard locations)
		$this->values["set_timers_tgd"]="99999999.tgd" ;
		$this->values["set_timers_rem"]=$this->values["epg_data"] ;
		$this->values["set_timers_loc"]=$this->values["local_files"] ;
		 
		 // These are the default values used when creating new timers
		$this->values["default_duration"]="120" ;
		$this->values["default_prepad"]="-05" ;
		$this->values["default_postpad"]="+10" ;
		$this->values["default_padding"]=$this->values["default_prepad"]." ".$this->values["default_postpad"] ;
		 
		 // Recordings location (may reference standard locations)
		$this->values["recordings_dir"]=$this->values["data_files"] ;
		 
		 // for calculating % utilisation of the Toppy HDD
		 // The first line is the size in GB (the decimal version normally used by HDD manufacturers)
		 // The second line multiplies this to get the actual byte count
		$this->values["hdd_size_GB"]=250.0 ;
		$this->values["hdd_size"]=$this->values["hdd_size_GB"]*1000.0*1000.0*1000.0 ;
		 
		 // Translation table: Toppy name to EPG name
		 // Also used to build Channel list for add/edit timer
		 // The Channel order here determines the order of the channel columns in the EPG display
		 $chn_names["ABC TV NSW"] = "ABC";
		 $chn_names["ABC2"] = "ABC2";
		 $chn_names["7 Digital"] = "Seven";
		 $chn_names["NINE DIGITAL"] = "Nine";
		 $chn_names["TEN Digital"] = "TEN";
		 $chn_names["SBS DIGITAL 1"] = "SBS";
		 $chn_names["SBS DIGITAL 2"] = "SBS News";
		 // then flag any that you want to hide (add lines here for any channels which should NOT appear on the EPG display)
		 $chn_hide["SBS News"] = true ;  // Hide this channel from the EPG - set to true or false	
		 
		 // Default all channels to display (do NOT change this line)
		 foreach ($chn_names as $key => $value) 
		 {
		  if (! array_key_exists($value,$chn_hide)) {$chn_hide[$value] = false ; } 
		 }	 
		 
		$this->values["chn_names"]=$chn_names ;
		$this->values["chn_hide"]=$chn_hide ;
		 
		 // Do you want to show VCR timers (eg PBK time set) on the EPG display?
		$this->values["show_vcr_timers_on_epg"]=true ;
		$this->allowed_values["show_vcr_timers_on_epg"]="boolean" ;
		 
		 // number of days/dates to show in list when creating a new timer
		$this->values["number_days"]=30 ;
		 
		 // details of files for list of log files to display
		 //
		 // list_file_entry   is the name that appears in the selection list
		 // list_file_name    is the actual name of the file (may refer to a previously defined value)
		 // list_file_type    is how Toppy-Web finds the the file ("ftp" or "local")
		 // list_file_loc     is the location of the file (may refer to a standard location)
		 
		 $list_file_entry["epg_timers"] = "EPG timer list";
		 $list_file_name["epg_timers"]  = $epg_timers;
		 $list_file_type["epg_timers"]  = "ftp" ;
		 $list_file_loc["epg_timers"]   = $epg_data ;
		 $list_file_condition["epg_timers"]   = "always" ;
		 
		 $list_file_entry["99999999"] = "99999999.tgd";
		 $list_file_name["99999999"]  = $set_timers_tgd;
		 $list_file_type["99999999"]  = "ftp" ;
		 $list_file_loc["99999999"]   = $epg_data ;
		 $list_file_condition["99999999"]   = "always" ;
		 
		 $list_file_entry["epg_upload"]  = "EPG upload log";
		 $list_file_name["epg_upload"]   = "epg_upload.log";
		 $list_file_type["epg_upload"]   = "ftp" ;
		 $list_file_loc["epg_upload"]    = $epg_data ;
		 $list_file_condition["epg_upload"]   = "always" ;
		 
		 $list_file_entry["ted_log"]  = "TED log";
		 $list_file_name["ted_log"]   = "TED.log";
		 $list_file_type["ted_log"]   = "local" ;
		 $list_file_loc["ted_log"]    = $teds_location ;
		 $list_file_condition["ted_log"]   = "use_teds" ;
		 
		 $list_file_entry["ted_timers"]  = "TED timers log";
		 $list_file_name["ted_timers"]   = "timers.log";
		 $list_file_type["ted_timers"]   = "local" ;
		 $list_file_loc["ted_timers"]    = $teds_location ;
		 $list_file_condition["ted_timers"]   = "use_teds" ;
		 
		 $list_file_entry["xmltvcs_log"]  = "XMLTVcs log";
		 $list_file_name["xmltvcs_log"]   = "XMLTVcs.log";
		 $list_file_type["xmltvcs_log"]   = "local" ;
		 $list_file_loc["xmltvcs_log"]    = $teds_location ;
		 $list_file_condition["epg_timers"]   = "use_teds" ;
		 
		 $list_file_entry["xmltvtvw_log"]  = "XMLTVtvw log";
		 $list_file_name["xmltvtvw_log"]   = "XMLTVtvw.log";
		 $list_file_type["xmltvtvw_log"]   = "local" ;
		 $list_file_loc["xmltvtvw_log"]    = $teds_location ;
		 $list_file_condition["xmltvcs_log"]   = "use_teds" ;
		 
		 $list_file_entry["trecx_log"]  = "TrecX log";
		 $list_file_name["trecx_log"]   = "trecx.log";
		 $list_file_type["trecx_log"]   = "local" ;
		 $list_file_loc["trecx_log"]    = $teds_location ;
		 $list_file_condition["trecx_log"]   = "use_teds" ;
		 
		 $list_file_entry["timesynch"]  = "PBK Time Synch log";
		 $list_file_name["timesynch"]   = "TimeSync.log";
		 $list_file_type["timesynch"]   = "ftp" ;
		 $list_file_loc["timesynch"]    = $program_files."/Auto Start" ;
		 $list_file_condition["timesynch"]   = "use_pbk" ;
		 
		$this->values["list_file_entry"]=$list_file_entry ;
		$this->values["list_file_name"]=$list_file_name ;
		$this->values["list_file_type"]=$list_file_type ;
		$this->values["list_file_loc"]=$list_file_loc ;
		$this->values["list_file_condition"]=$list_file_condition ;
		 
		 
		 // EPG display values
		$this->values["show_epg"]=true ;
		$this->values["screen_width"]=1024 ;
		$this->values["hour_height"]=150 ;
		$this->values["hide_description"]=false ;
		$this->values["epg_source_type"]="xml" ;
		$this->allowed_values["epg_source_type"]=array("xml","ice") ;
		$this->values["epg_xmlSource"]=$teds_location."\\TVGuide2\\listings.xml" ;
		$this->values["epg_ICE_type"]="ftp" ;
		$this->allowed_values["epg_ICE_type"]=array("local","ftp") ;
		$this->values["epg_ICE_location"]="/ICE" ;
		 	 
?>