<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

* Redistributions must retain the above copyright
notice, this list of conditions and the following disclaimer.

* The name of John Stevens may not
be used to endorse or promote products derived from this
software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php include_once ("config_ini.php"); ?>
<?php include_once ("version.php"); ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
  <title>Toppy-Web EPG <?= $version ?></title>
	<script src='ajax_lib.js'></script>
	<script src='epg.js'></script>
	<script src='cookies.js' type="text/javascript"></script>
  <style>
    @import "toppy-web.css";
  </style>

<script language="JavaScript">
<!--
var number_days, default_duration, default_padding, hour_height, screen_width, set_scroll, mouseover_compare_inner ;
 var use_ajax = <?= $use_ajax ? "true" : "false"; ?>;
 var ajax_timer_node =  [] ;
 var ajax_http_request =  [] ;
 var ajax_http_response =  [] ;

function initialise_defaults() {

 theForm          = document.getElementById("form_js") ;
 number_days      = theForm.number_days.value ;
 default_duration = theForm.default_duration.value ;
 default_padding  = theForm.default_padding.value ;
 hour_height      = theForm.hour_height.value ;
 screen_width     = theForm.screen_width.value ;
 set_scroll       = theForm.set_scroll.value ;
 mouseover_compare_inner = (theForm.mouseover_compare_inner.value=="Yes") ;
 
}
//-->

</script>
</head>

<body onload='initialise_defaults();initialise_epg();' class='epg_body'>
<form name="form_js" id="form_js" style="display:none;">
<input type="hidden" name="number_days" value="<?= $number_days ?>">
<input type="hidden" name="default_duration" value="<?= $default_duration ?>">
<input type="hidden" name="default_padding" value="<?= $default_padding ?>">
<input type="hidden" name="hour_height" value="<?= $hour_height ?>">
<input type="hidden" name="screen_width" value="<?= $screen_width ?>">
<input type="hidden" name="mouseover_compare_inner" value="<?= yes_if_true($mouseover_compare_inner) ?>">
<input type="hidden" name="set_scroll" value="<?= ($set_scroll = trim($_POST["set_scroll"])) ?>">
</form>

<?php include "links.php" ?>

<?php

include_once "ajax_support.php";

if (!$demo_mode)
{
  // first see if any servers need waking
  foreach ($MyToppies as $servername)
  {
    wake_server($servername);
  }

  add_diag("EPG starting");

  include ("epg_timer_action.php");
  sleep(1); // give the ftp time to settle
}

//if($_POST["set_day"]) { $current_date=$_POST["set_day"] ; }
if (array_key_exists("set_day", $_POST))
{
  $current_date = $_POST["set_day"];
} else
{
  $current_date = strtotime("now") - 6 * 60 * 60;
}
if ($_POST["set_day"] == "")
{
  $current_date = strtotime("now") - 6 * 60 * 60;
}
//echo "set_day=".date("Ymd H:i",$_POST["set_day"])." \n" ;

$current_date = find_midnight($current_date);
//$current_date += date("Z",$current_date) ; // adjust for local time offset
//$current_date -= $current_date % (60*60*24) ; //adjust back to UTC midnight
//$current_date -= date("Z",$current_date) ; // adjust to local midnight using the offset
echo "<!-- EPG date => " . date("Ymd H:i", $current_date) . " -->\n";

if ($force_current_date > "")
{
  $current_date = $force_current_date;
}

$start_timestamp = $current_date + 6 * 60 * 60; // set start time to 6am
$end_timestamp = $start_timestamp + 24 * 60 * 60; // set end time to 24 hours later
// now convert them both to a yyyymmddhhmmss string
$start_time = date("YmdHi", $start_timestamp);
$end_time = date("YmdHi", $end_timestamp);

$programmes = array(); // array to hold all the programme data
$channels = array(); // array to hold the list of channels that exist in the EPG data

add_diag("EPG loading EPG");
echo "<!-- Loading EPG -->\n";

ini_set("display_errors", 0);

$use_current_cache = false; // assume no cache
if ($force_cache)
{
  $result = false;
  echo "<!-- Forcing EPG cache -->\n";
} else
{
  if ($cache_epg_enabled)
  {
    include ("epg_cache_manage.php");
  }
  if ($use_current_cache)
  {
    $result = false;
  } else
  {
    echo "<!-- EPG Including $epg_type code -->\n";
    //***************************************************************************************************
    //   Include the epg fetching code then
    //		Call the parseFile() and get the result out in a simple table
    //***************************************************************************************************
    if ($epg_type == "tgd")
    {
      include ("epg_tgd.php");
    }
    if ($epg_type == "xml")
    {
      include ("epg_xml.php");
    }
    if ($epg_type == "ice")
    {
      include ("epg_ice.php");
    }
    if ($epg_type == "mei")
    {
      include ("epg_mei.php");
    }

    $result = parseFile();

    echo "<!-- EPG Programmes => " . is_true($result, count($result) . " entries loaded",
      "Load from source failed") . " -->\n";
    //dump_epg($result) ;
  }
}

if ($result === false)
{
  if ($cache_epg_enabled)
  {
    $epg_cache = unserialize($get_cache = file_get_contents($local_files . DIRECTORY_SEPARATOR . $current_date .
      "_epg_cache"));
    echo "<!-- EPG Reading cache file " . $local_files . DIRECTORY_SEPARATOR . $current_date .
      "_epg_cache" . " -->\n";
    if ($get_cache)
    {
      $result = $epg_cache["result"];
      $channels = $epg_cache["channels"];
      $pidtable = $epg_cache["pidtable"];
      $next_pid = $epg_cache["next_pid"];
    } else
    {
      $result = array();
      $channels = array();
      $pidtable = array();
      $last_pid = 0;
    }
  }
  echo "<!-- EPG Read from Cache => " . is_true($result, count($result) . " entries loaded",
    "Load from cache failed");
  //echo "\n";print_r($result) ;
  echo "-->\n";
} else
{
  if ($cache_epg_enabled)
  {
    if ($epg_cache_expired)
    {
      retain_old_pidtable($epg_cache_expired);
    } else
    {
      build_new_pidtable();
    }
    $epg_cache["result"] = $result;
    $epg_cache["channels"] = $channels;
    $epg_cache["pidtable"] = $pidtable;
    $epg_cache["next_pid"] = $last_pid;
    file_put_contents($local_files . DIRECTORY_SEPARATOR . $current_date . "_epg_cache", serialize($epg_cache));
    echo "<!-- EPG writing Cache => " . count($result) . " entries written -->\n";
  }
}

ini_set("display_errors", 1);

echo "<!-- EPG loaded -->\n";

add_diag("EPG finished loading EPG");

add_diag("EPG building page headers");

// configurable values (flexible) are in config.php

// design values (fixed)
$epg_top = 50; // top of main EPG display
$epg_margin = 10;
$chn_head_height = 20;
$epg_footer_height = 30;
$time_head_width = 60;
$epg_banner_height = 60;
$window_allowance = 50; // window frame, scroll bar, etc

// derived values (calculated from other settings)

if ($hide_description)
{
  $desc_display = "none";
} else
{
  $desc_display = "inline";
}

$channel_left = array();

// number of channels in the EPG data
$chn_count = max(count($channels), 1);
// width of each channel column
$chn_width = floor(($screen_width - $window_allowance - ($epg_margin * 2) - $time_head_width) / $chn_count);
$timer_width = min(max(floor($chn_width / 15), 8), 10);

// width of the epg display
$epg_width = $time_head_width + ($chn_width * $chn_count);

// total height of all EPG headers
$epg_head_height = $chn_head_height + $epg_banner_height;

$thisdate = date("Ymd", $current_date);

?>
<script type="text/javascript">
    <!--
	var chn_count = <?= $chn_count ?>;
	var hour_height = <?= $hour_height ?>;
	var chn_width = <?= $chn_width ?>;
	var epg_head_height = <?= $epg_head_height ?>;
	var epg_banner_height = <?= $epg_banner_height ?>;
	var thisdate = <?= $thisdate ?>;
	var epg_top = <?= $epg_top ?>; // top of main EPG display
	var epg_margin = <?= $epg_margin ?> ;
	var chn_head_height = <?= $chn_head_height ?> ;
	var epg_footer_height = <?= $epg_footer_height ?> ;
	var time_head_width = <?= $time_head_width ?> ;
	var window_allowance = <?= $window_allowance ?> ; // window frame, scroll bar, etc
	var prog_min_top = <?= ($epg_top + $epg_margin + $chn_head_height) ?> ;
	var prog_max_bot = prog_min_top + <?= ($hour_height * 24) ?> ;
	//-->
</script>
<?PHP

if (false)
{
  echo "<div style='position:fixed; top:200px; left:1000px; z-index: 99;'>\n";
  for ($i = 0; $i < 7; $i++)
  {
    $x_day = strtotime("+$i days");
    echo "&nbsp;<input type='button' value='" . date("D", $x_day) . "' onclick='click_day($x_day);' style='width: 35px;' /><br />\n";
  }
  echo "</div>\n";
}


// create the epg parent div
$d_top = ($epg_top) . "px";
$d_left = ($epg_margin) . "px";
$d_width = ($epg_width) . "px";
$d_height = $epg_total_height = ($epg_head_height + $chn_head_height + $epg_footer_height + ($hour_height *
  24)) . "px";
echo "<div id='epg_detail' style='visibility:hidden; position:absolute; top:$d_top; left:$d_left; height:$d_height; width:$d_width'>\n";
//echo "<div id='epg_detail' style='visibility:hidden; left:$d_left; height:$d_height; width:$d_width'>\n" ;

// Build the banner block
$d_top = (0) . "px";
$d_left = (0) . "px";
$d_width = ($epg_width) . "px";
$d_height = ($epg_banner_height) . "px";
echo "<div id='epg_banner' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; width:$d_width'>\n";
echo "TV guide: " . date("l d M Y", $current_date) . "<br />\n";

$side_time_button_block_height = 152; // fixed value determined to make the buttons center vertically
$side_day_button_block_height = (20 * $days_displayed); // fixed value determined to make the buttons center vertically
echo "<!-- $side_day_button_block_height -->\n";
$day_buttons_horizontal = "";
$day_buttons_vertical = "<div id='inner' style='position:absolute; top:9px;'>\n";
if ($days_displayed > 7)
{
  $day_type = "D";
} else
{
  $day_type = "l";
}
for ($i = 0; $i < $days_displayed; $i++)
{
  $x_day = strtotime("+$i days") - 6 * 60 * 60;
  //if ( date("w",strtotime("+$i days")) == date("w",$start_timestamp) ) {$day_class = "day_current" ;}
  if (date("d", $x_day) == date("d", $start_timestamp))
  {
    $day_class = "day_current";
  } else
  {
    $day_class = "day_other";
  }
  $day_buttons_horizontal .= "&nbsp;<input type='button' class='$day_class' value='" . date($day_type,
    $x_day) . "' onclick='click_day($x_day);' />\n";
  $day_buttons_vertical .= "<input type='button' class='$day_class' value='" . substr(date("D", $x_day),
    0, 1) . "' onclick='click_day($x_day);' style='width:20px; font-size:8pt;' /><br />\n";
}
$day_buttons_vertical .= "</div>\n";

echo $day_buttons_horizontal;
echo "</div>\n";

// Build the footer block
$d_top = ($epg_total_height - $epg_footer_height) . "px";
$d_height = ($epg_footer_height) . "px";
echo "<div id='epg_footer' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; width:$d_width'>\n";
echo $day_buttons_horizontal;
echo "</div>\n";

$time_buttons_vertical = "<div id='inner' style=''>\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='6'  onclick='click_hour(0);'  style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='9'  onclick='click_hour(3);'  style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='N' onclick='click_hour(6);'  style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='3' onclick='click_hour(9);'  style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='6' onclick='click_hour(12);' style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='9' onclick='click_hour(15);' style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='M' onclick='click_hour(18);' style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .=
  "<input type='button' class='time_button' value='3'  onclick='click_hour(21);' style='width:20px; font-size:8pt;' /><br />\n";
$time_buttons_vertical .= "</div>\n";

// Build the side button blocks
for ($i = 1; $i < (24 / 3); $i += 1)
{
  $d_top = (($i * 3 * $hour_height) - ($side_day_button_block_height / 2) + $epg_head_height) . "px";
  $d_left = "0px";
  $d_height = $side_day_button_block_height . "px";
  echo "<div id='epg_side$i' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; z-index:9;'>\n";
  echo $day_buttons_vertical;
  echo "</div>\n";
}

for ($i = 0; $i < (24 / 3); $i += 1)
{
  $d_top = (($i * 3 * $hour_height) + ($hour_height * 1.5) - ($side_time_button_block_height / 2) + $epg_head_height) .
    "px";
  $d_left = "0px";
  $d_height = $side_time_button_block_height . "px";
  echo "<div id='epg_time$i' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; z-index:9;'>\n";
  echo $time_buttons_vertical;
  echo "</div>\n";
}

echo "<!-- Programmes=" . count($result) . " end=" . $end_time . " Channels=" . count($chn_names) .
  " -->\n";

// Build the time bar on the side
$time_bar = "";
for ($i = 0; $i <= 1440; $i += 30)
{
  $j = ($i + 360) % 1440; // offset to 6am
  $x = 10000 + 100 * floor($j / 60) + ($j % 60) . " ";

  $d_top = round($epg_head_height - 8 + ($hour_height * $i) / 60) . "px";
  $d_left = "0px";
  $d_width = ($time_head_width - 0) . "px";
  $d_height = round(($hour_height * 30) / 60) . "px";
  $time_bar .= "<div class='time_head' style='position:absolute; top:$d_top; left:$d_left; width:$d_width; height:$d_height; z-index:8;'>" .
    substr($x, 1, 2) . ":" . substr($x, 3, 2) . "</div>\n";
}
echo $time_bar;

// left bit of the Channel bar
$d_top = ($epg_banner_height) . "px";
$d_left = "0px";
$d_height = $chn_head_height . "px";
$d_width = ($time_head_width - 0) . "px";
echo "<div class='chn_head' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; width:$d_width'></div>\n";
//$d_top = ($epg_head_height+24*$hour_height)."px" ;
//echo "<div class='chn_head' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; width:$d_width'>06:00</div>\n" ;

add_diag("building EPG");

// For each Channel
$chn_left = $time_head_width;
foreach ($chn_names as $chn_index => $chn_value)
{
  if ($chn_hide[$chn_value])
  {
    continue;
  }

  add_diag("starting channel $chn_value");

  add_diag("EPG " . $chn_value . "=" . is_true(array_key_exists($chn_value, $channels), "Exists",
    "Missing"));
  if (array_key_exists($chn_value, $channels))
  {
    // Build the Channel bar
    $d_top = ($epg_banner_height) . "px";
    $d_left = ($chn_left) . "px";
    $d_height = $chn_head_height . "px";
    $d_width = ($chn_width - 0) . "px";
    $channel_left[$chn_value] = $chn_left; // store channel left position
    echo "<div class='chn_head' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; width:$d_width'>$chn_value</div>\n";
    $d_top = ($epg_head_height + 24 * $hour_height) . "px";
    echo "<div class='chn_head' style='position:absolute; top:$d_top; left:$d_left; height:$d_height; width:$d_width'>$chn_value</div>\n";

    // Now add the programme entries
    //echo "results=".count($result)."\n" ;
    foreach ($result as $prog)
    {
      if ($prog["epgChannel"] == $chn_value)
      {
        $progdate = substr($prog["epgStart"], 0, 8);
        display_prog($prog); // Display this Programme for this Channel
      }
    } // Next Programme
    $chn_left += $chn_width;
  }
  add_diag("finished channel $chn_value");
} // Next Channel

add_diag("finished EPG");

add_diag("building timers");
// No overlay any existing and pending timer entries
include ("epg_timer_display.php");

add_diag("finished timers");


if ($mouseover_desc)
{
  $d_desc = "inline";
} else
{
  $d_desc = "none";
}
?>
 
<!-- This div contains the hidden mouseover div --> 
 
 <div id='div_mouseover' class='mouseover_display' style='visibility:hidden; top:0px; left:0px; width:200px; bottom:auto; position:absolute;'>
  <div id='mouseover_inner' style='margin:20px;'>
   <span id="mouseover_channel" class='mouseover_channel_display'>$time</span><br />
   <span id="mouseover_time" class='mouseover_time_display'>$time</span>
   <span id="mouseover_title" class='mouseover_title_display'>$title</span>
   <span id="mouseover_subtitle" class='mouseover_subtitle_display'> ($subtitle)</span>
   <span id="mouseover_quality" class='mouseover_title_display'>.$quality</span>
   <br />
	 <span id="mouseover_desc" class='mouseover_desc_display' style='display: <?= $d_desc ?>;'>$desc</span>
   <span id="mouseover_duration" class='mouseover_duration_display'>$duration</span>
  </div>
 </div>
 <?php

echo "</div>\n"; // end the EPG parent div

//
// Now build the hidden timer form along with all the EPG data in named spans
//
// Create a non-display DIV
echo "<div id='div_epgdata' style='display: none;'>\n";
foreach ($result as $index => $prog)
{
  $pid = $prog["epgPID"];
  $title = fix_chars($prog["epgTitle"]);
  $subtitle = ereg_replace("\[.*\]", "", fix_chars($prog["epgSubTitle"]));
  if ($subtitle)
  {
    $filename = "$title ($subtitle)";
  } else
  {
    $filename = $title;
  }
  list($duration) = sscanf($prog["epgDuration"], "%d ");
  $channel = $prog["epgChannel"];
  $desc = fix_chars($prog["epgDescription"]);
  $quality = fix_chars($prog["epgQuality"]);
  $start = $prog["epgStart"];
  $stop = $prog["epgStop"];
  $start_hour = substr($start, 8, 2);
  $start_min = substr($start, 10, 2);
  $start_datestamp = strtotime(substr($start, 4, 2) . "/" . substr($start, 6, 2) . "/" . substr($start,
    0, 4) . " " . substr($start, 8, 2) . ":" . substr($start, 10, 2));
  $start_date = date("l jS F Y", $start_datestamp);

  // store the data in named SPANs
  echo "<span id='prog_title_$pid'>$title </span>";
  if ($subtitle)
  {
    echo "<span id='prog_subtitle_$pid'> ($subtitle)</span>";
  } else
  {
    echo "<span id='prog_subtitle_$pid'>.</span>";
  }
  echo "<span id='prog_date_$pid'>$start_date</span>";
  echo "<span id='prog_datestamp_$pid'>" . date("Y-m-d H:i", $start_datestamp) . "</span>";
  echo "<span id='prog_time_$pid'>$start_hour:$start_min </span>";
  echo "<span id='prog_duration_$pid'>$duration </span>";
  echo "<span id='prog_channel_$pid'>$channel</span>";
  echo "<span id='prog_desc_$pid'>$desc </span>";
  echo "<span id='prog_quality_$pid'>$quality.</span>";
  echo "\n";
}
echo "</div>\n";

?>
 
<!-- This div contains the hidden timer creation form --> 
 
<div id='div_addtimer' class='prog_display' style='visibility:hidden; top:100px;'>
 <div id='inner' style='margin:20px;'>
 <form id="form_addtimer" name="form_addtimer" method="POST" action="<?= $_SERVER['SCRIPT_NAME'] ?>			 ">
 <span id="prog_title" class='prog_title_display'>$title</span>
 <span id="prog_subtitle" class='prog_subtitle_display'> ($subtitle)</span>
 <br /><span id="prog_date" class='prog_time_display'>$date</span>
  at <span id="prog_time" class='prog_time_display'>$time</span>
	for <span id="prog_duration" class='prog_time_display'>$duration</span>
	on <span id="prog_channel" class='prog_time_display' style='display:inline;'>$channel</span>
	<span id="prog_channel_alt" class='prog_time_display' style='display:none;'>
	 <select name="set_newchannel">
	  <option selected='selected'>$channel</option>
	 </select>
	</span>
 <br /><span id="prog_desc" class='prog_desc_display'>$desc</span>
 <br /><br /><b>Create a timer for this programme</b><br />
 <table>
 <tr>
  <td>PVR name:</td>
  <td>
	 <select name="set_server">
	  <?php foreach ($MyToppies as $servername)
{
  echo "<option value='$servername'>$servername</option>\n";
} ?>
	 </select>
  </td>
 </tr>
 <tr><td>Timer name:</td><td><input type="text" name="set_newname" size=60 value="<?= $filename ?>"></td></tr>
 <tr><td>Padding:</td><td><input type="text" name="set_newpadding" size=8 value="<?= $default_padding ?>"></td></tr>
 <tr><td><input type='button' value='Add timer' onClick='click_display_action(this.form);'></td>
 <td align="right"><input type='button' value='Cancel' onClick='click_display_close();'></td></tr>
 </table>
 <input type="hidden" name="set_action" value="Add">
 <!-- <input type="hidden" name="set_newchannel" value="$channel"> -->
 <input type="hidden" name="set_newstart" value="$start_datestamp)">
 <input type="hidden" name="set_newduration" value="$duration">
 <input type="hidden" name="set_pid" value="$pid">
 <input type="hidden" name="set_scroll" value="">
 <input type="hidden" name="set_day" value="<?= $current_date ?>">
 </form>
 </div>
</div>

<?PHP
echo "<script language='JavaScript'>\n";
$chn_string = "var chn_list = new Array(";
$alt_string = "var alt_list = new Array(";
$hd_string = "var hd_list = new Array(";
$x = "";
foreach ($Channels as $index => $value)
{
  $chn_string .= $x . '"' . $value . '"';
  $alt_string .= $x . '"' . $chn_alternate[$value] . '"';
  $hd_string .= $x . '"' . $chn_hdtv[$value] . '"';
  $x = ",";
}
$chn_string .= ");\n";
$alt_string .= ");\n";
$hd_string .= ");\n";
echo $chn_string . $alt_string . $hd_string . "var chn_count=$index;\n";
echo "</script>\n";
?>

<!-- This div contains the day selection form -->

<div style='visibility: hidden;'>
 <form id="form_day" name="form_day" method=POST action="<?= $_SERVER['SCRIPT_NAME'] ?>">
  <input type="hidden" name="set_action" value="Day">
  <input type="hidden" name="set_day" value="">
 </form>
</div>

<?php
add_diag("finished page");
if ($show_diag)
{
  create_diag();
}
?>
</body>
</html>

<?php
function display_prog($prog)
{
  global $hour_height, $chn_left, $epg_top, $chn_width, $timer_width, $epg_head_height, $start_timestamp,
    $desc_display;
  global $mouseover_display, $chn_count;

  $pid = $prog["epgPID"];
  $title = fix_chars($prog["epgTitle"]);
  $subtitle = fix_chars($prog["epgSubTitle"]);
  //if($subtitle) {$title .= " : $subtitle" ; }
  list($duration) = sscanf($prog["epgDuration"], "%d ");
  $channel = $prog["epgChannel"];
  $desc = fix_chars($prog["epgDescription"]);
  $start = $prog["epgStart"];
  $stop = $prog["epgStop"];
  $repeat = $prog["epgRepeat"];
  $start_hour = substr($start, 8, 2);
  $start_min = substr($start, 10, 2);
  $start_offset = strtotime(substr($start, 4, 2) . "/" . substr($start, 6, 2) . "/" . substr($start, 0,
    4) . " " . substr($start, 8, 2) . ":" . substr($start, 10, 2));
  $start_offset -= $start_timestamp;
  //echo $start_offset ;
  if ($start_offset < 0)
  {
    $adj_duration = $duration + $start_offset / 60; // reduce duration by the excessive offset (minutes)
    $start_offset = 0;
  } else
  {
    $adj_duration = $duration;
  }

  if (!(strpos($title, "[Rpt]") or strpos($desc, "[Rpt]")) and $repeat)
  {
    $title .= " [Rpt]"; // if [Rpt] does not appear anywhere and should then append it to the Title
  }
  if ($prog["epgQuality"])
  {
    $title .= " [" . $prog["epgQuality"] . "]";
  }

  $chn_string = "<a name='anchor$pid'>";
  $chn_string .= "<span class='prog_time'>$start_hour:$start_min</span>";
  $chn_string .= "</a> ";
  $chn_string .= "<span class='prog_title'>$title</span>";
  if ($subtitle)
  {
    $chn_string .= "<span class='prog_subtitle'> ($subtitle)</span>";
  }
  $chn_string .= "<br />";
  //$chn_string .= "<span class='prog_desc'>$desc</span>" ;
  $chn_string .= "<span id='epgdesc$pid' class='prog_desc' style='display: $desc_display;'>$desc</span>";
  $chn_string .= " ";
  $chn_string .= "<span class='prog_duration'>($duration)</span>";

  if (strpos($title, "[Rpt]") or strpos($desc, "[Rpt]") or $repeat)
  {
    $chn_class = "prog_detail_rpt";
  } else
  {
    $chn_class = "prog_detail";
  }

  if ($mouseover_display >= $duration and $chn_count > 1)
  {
    $mouseover_action = "mouseover_show(this,$pid);";
    $mouseout_action = "mouseover_hide(this,$pid);";
  } else
  {
    $mouseover_action = "";
    $mouseout_action = "";
  }

  // positioning
  $d_top = ($x_top = round($epg_head_height + ($y_top = ($hour_height * ($start_offset / 3600))))) .
    "px";
  $d_height = ($x_height = round(($hour_height * ($adj_duration)) / 60)) . "px";
  if (($y_height = (($y_top + $x_height) - (24 * $hour_height))) > 0)
  {
    $d_height = ($x_height = $x_height - $y_height) . "px";
  }
  $d_width = ($chn_width - 0) . "px";
  $d_left = $chn_left . "px";
  $x_right = $chn_left + $chn_width;
  $inner_right = ($timer_width + 2) . "px";
  echo "<div id='prog_$pid' class='$chn_class' style='position: absolute ; top: $d_top; height: $d_height; left: $d_left; width:$d_width;' onMouseOver='highlight_entry(this);$mouseover_action' onMouseOut='lowlight_entry(this);$mouseout_action' onClick='click_entry(this,$pid,$x_top,$x_right,$x_height);'>\n";
  //echo "$start_hour:$start_min($duration):$d_top,$d_height $title<br>\n" ;

  echo "<div id='inner_$pid' style='margin:3px; margin-right:$inner_right;'>\n";
  echo "$chn_string\n";
  echo "</div>\n";
  echo "</div>\n";
}

// fix any wayward characters and trim the result
function fix_chars($input)
{
  //$input = str_replace("'"," ",$input) ;
  $input = str_replace("", "-", $input);
  $input = str_replace("ü", "u", $input);
  return trim($input);
}

function dump_epg($epg)
{
  foreach ($epg as $prog)
  {
    echo $prog["epgChannel"] . "=" . $prog["epgTitle"] . "<br>\n";
  }
}

function epg_clean_cache($today)
{
  if (array_key_exists("epg_last_clean", $_COOKIE))
  {
    $last_clean = $_COOKIE["epg_last_clean"];
  } else
  {
    $last_clean = 0;
  }
  if ($last_clean >= $today)
  {
    return;
  }

  echo "<script language='JavaScript' type='text/javascript'>\n";
  echo "<!--\n";
  echo "SetCookie( 'epg_last_clean', '$today') ;\n";
  echo "//-->\n";
  echo "</script>\n";
  return;
}

function find_midnight($datevalue)
{
  $datevalue += date("Z", $datevalue); // adjust for local time offset
  $datevalue -= $datevalue % (60 * 60 * 24); //adjust back to UTC midnight
  //echo "current=".date("Ymd H:i",$current_date)." \n" ;
  $datevalue -= date("Z", $datevalue); // adjust to local midnight using the offset
  return $datevalue;
}

?>
